<?php

add_filter( 'it_storage_filter_load_layout_settings', 'it_set_default_layouts' );

function it_set_default_layouts( $defaults ) {
	if ( isset( $defaults ) && is_array( $defaults ) && isset( $defaults['default'] ) )
		return $defaults;
	if ( ! is_array( $defaults ) )
		$defaults = array();
	
	$new_defaults = array(
		'storage_version'	=> '1.0',
		'default'	=> '960-home',
		'layouts'	=> array(
			'780-home'	=> array(
				'description'	=> '780 Home',
				'width'			=> '780',
				'modules'		=> array(
					array(
						'module'	=> 'navigation',
						'data'		=> array(
							'type'		=> 'pages',
						),
					),
					array(
						'module'	=> 'navigation',
						'data'		=> array(
							'type'		=> 'categories',
						),
					),
					array(
						'module'	=> 'widget-bar',
						'data'		=> array(
							'type'				=> '2',
							'name'				=> 'Above Content',
							'widget_percents'	=> '50,50',
						)
					),
					array(
						'module'	=> 'content',
						'data'		=> array(
							'sidebar'				=> '2_right',
							'sidebar_widths'		=> '150,200',
							'custom_sidebar_widths'	=> '',
						),
					),
					array(
						'module'	=> 'widget-bar',
						'data'		=> array(
							'type'				=> '1',
							'name'				=> 'Below Content Widget',
							'widget_percents'	=> '100',
						),
					),
					array(
						'module'	=> 'widget-bar',
						'data'		=> array(
							'type'				=> '3',
							'name'				=> 'Footer Widgets',
							'widget_percents'	=> '33.33,33.33,33.33',
						),
					),
					array(
						'module'	=> 'footer',
						'data'		=> array(
							'sidebar'				=> 'none',
							'sidebar_widths'		=> '',
							'custom_sidebar_widths'	=> '',
						),
					),
				),
			),
			'780-inside'	=> array(
				'description'	=> '780 Inside',
				'width'			=> '780',
				'modules'		=> array(
					array(
						'module'	=> 'navigation',
						'data'		=> array(
							'type'		=> 'pages',
						),
					),
					array(
						'module'	=> 'navigation',
						'data'		=> array(
							'type'		=> 'categories',
						),
					),
					array(
						'module'	=> 'widget-bar',
						'data'		=> array(
							'type'				=> '2',
							'name'				=> 'Above Content',
							'widget_percents'	=> '50,50',
						)
					),
					array(
						'module'	=> 'content',
						'data'		=> array(
							'sidebar'				=> '2_right',
							'sidebar_widths'		=> '150,200',
							'custom_sidebar_widths'	=> '',
						),
					),
					array(
						'module'	=> 'widget-bar',
						'data'		=> array(
							'type'				=> '1',
							'name'				=> 'Below Content Widget',
							'widget_percents'	=> '100',
						),
					),
					array(
						'module'	=> 'widget-bar',
						'data'		=> array(
							'type'				=> '3',
							'name'				=> 'Footer Widgets',
							'widget_percents'	=> '33.33,33.33,33.33',
						),
					),
					array(
						'module'	=> 'footer',
						'data'		=> array(
							'sidebar'				=> 'none',
							'sidebar_widths'		=> '',
							'custom_sidebar_widths'	=> '',
						),
					),
				),
			),
			'960-home'	=> array(
				'description'	=> '960 Home',
				'width'			=> '960',
				'modules'		=> array(
					array(
						'module'	=> 'navigation',
						'data'		=> array(
							'type'		=> 'pages',
						),
					),
					array(
						'module'	=> 'navigation',
						'data'		=> array(
							'type'		=> 'categories',
						),
					),
					array(
						'module'	=> 'widget-bar',
						'data'		=> array(
							'type'				=> '2',
							'name'				=> 'Above Content',
							'widget_percents'	=> '50,50',
						)
					),
					array(
						'module'	=> 'content',
						'data'		=> array(
							'sidebar'				=> '2_right',
							'sidebar_widths'		=> '150,200',
							'custom_sidebar_widths'	=> '',
						),
					),
					array(
						'module'	=> 'widget-bar',
						'data'		=> array(
							'type'				=> '1',
							'name'				=> 'Below Content Widget',
							'widget_percents'	=> '100',
						),
					),
					array(
						'module'	=> 'widget-bar',
						'data'		=> array(
							'type'				=> '3',
							'name'				=> 'Footer Widgets',
							'widget_percents'	=> '33.33,33.33,33.33',
						),
					),
					array(
						'module'	=> 'footer',
						'data'		=> array(
							'sidebar'				=> 'none',
							'sidebar_widths'		=> '',
							'custom_sidebar_widths'	=> '',
						),
					),
				),
			),
			'960-inside'	=> array(
				'description'	=> '960 Inside',
				'width'			=> '960',
				'modules'		=> array(
					array(
						'module'	=> 'navigation',
						'data'		=> array(
							'type'		=> 'pages',
						),
					),
					array(
						'module'	=> 'navigation',
						'data'		=> array(
							'type'		=> 'categories',
						),
					),
					array(
						'module'	=> 'widget-bar',
						'data'		=> array(
							'type'				=> '2',
							'name'				=> 'Above Content',
							'widget_percents'	=> '50,50',
						)
					),
					array(
						'module'	=> 'content',
						'data'		=> array(
							'sidebar'				=> '2_right',
							'sidebar_widths'		=> '150,200',
							'custom_sidebar_widths'	=> '',
						),
					),
					array(
						'module'	=> 'widget-bar',
						'data'		=> array(
							'type'				=> '1',
							'name'				=> 'Below Content Widget',
							'widget_percents'	=> '100',
						),
					),
					array(
						'module'	=> 'widget-bar',
						'data'		=> array(
							'type'				=> '3',
							'name'				=> 'Footer Widgets',
							'widget_percents'	=> '33.33,33.33,33.33',
						),
					),
					array(
						'module'	=> 'footer',
						'data'		=> array(
							'sidebar'				=> 'none',
							'sidebar_widths'		=> '',
							'custom_sidebar_widths'	=> '',
						),
					),
				),
			),
		),
		'views'		=> array(),
	);
	
	return array_merge( $defaults, $new_defaults );
}

?>
