<?php

/* This file can be used to add additional functionality and customization to this Extension */


add_action( 'wp_print_scripts', 'builder_magazine_print_scripts' );

function builder_magazine_print_scripts() {
	it_classes_load( 'it-file-utility.php' );
	$base_url = ITFileUtility::get_url_from_file( dirname( __FILE__ ) );
	
	wp_enqueue_script( 'jquery' );
	wp_enqueue_script( 'builder_magazine_script', "$base_url/js/script.js" );
}

function magazine_style_content() {
	
?>
	<?php if ( have_posts() ) : while ( have_posts() ) : the_post(); // the loop ?>
	
	<!--Post Wrapper Class-->
	<div <?php post_class(); ?>>
	
	<!--Title/Date/Meta-->
	<div class="title clearfix">
		<?php if ( function_exists( 'has_post_image' ) ) : if ( has_post_image() ) : ?>
			<div class="thumbnail-wrap">
				<a href="<?php the_permalink(); ?>">
					<?php the_post_image( 'thumbnail', array( 'class' => 'thumbnail-image' ) ); ?>
				</a>
			</div>
		<?php endif; endif; ?>
		<div class="post-title">
			<h3 id="post-<?php the_ID(); ?>"><a href="<?php the_permalink() ?>" rel="bookmark" title="<?php the_title(); ?>"><?php the_title(); ?></a></h3>
		</div>
		<div class="post-meta">
			By
			<span class="meta-author"><?php the_author_posts_link(); ?></span> 
			<?php do_action( 'builder_comments_popup_link', '<span class="meta-comments">&middot; ', '</span>', __( 'Comments %s', 'it-l10n-Builder' ), __( '(0)', 'it-l10n-Builder' ), __( '(1)', 'it-l10n-Builder' ), __( '(%)', 'it-l10n-Builder' ) ); ?>
		</div>
		<div class="date">
			<span class="weekday"><?php the_time( 'l' ); ?><span class="weekday-comma">,</span></span>
			<span class="month"><?php the_time( 'F' ); ?></span>
			<span class="day"><?php the_time( 'j' ); ?><span class="day-suffix"><?php the_time( 'S' ); ?></span><span class="day-comma">,</span></span>
			<span class="year"><?php the_time( 'Y' ); ?></span>
		</div>
	</div>
	
	<!--post text with the read more link-->
	<div class="post-content">
		<?php the_excerpt(); ?>
		<a href="<?php the_permalink(); ?>" class="readmorelink"><span>READ MORE</span></a>
	</div>
	
	<!--post meta info-->
	<div class="meta-bottom clearfix">
		<div class="alignleft"><span class="categories">Categories : <?php the_category( ', ' ) ?></span></div>
		<?php do_action( 'builder_comments_popup_link', '<div class="alignright"><span class="comments">', '</span></div>', __( 'Comments %s', 'it-l10n-Builder' ), __( '(0)', 'it-l10n-Builder' ), __( '(1)', 'it-l10n-Builder' ), __( '(%)', 'it-l10n-Builder' ) ); ?>
	</div>
    
	</div><!--end .post-->
	
	<?php endwhile; // end of one post ?>
	
	<!-- Previous/Next page navigation -->
	<div class="paging clearfix">
		<div class="alignleft"><?php previous_posts_link( '&laquo; Previous Page' ); ?></div>
		<div class="alignright"><?php next_posts_link( 'Next Page &raquo;' ); ?></div>
	</div>
	
	<?php else : // do not delete ?>
	
	<div class="post">
	<h3><?php _e( 'Page not Found' ); ?></h3>
	<p><?php _e( 'We\'re sorry, but the page you\'re looking for isn\'t here.' ); ?></p>
	<p><?php _e( 'Try searching for the page you are looking for or using the navigation in the header or sidebar' ); ?></p>
	</div>
	
	<?php endif; // do not delete ?>
<?php
	
}

add_action( 'builder_layout_engine_render', 'change_render_content', 0 );

function change_render_content() {
	remove_action( 'builder_layout_engine_render_content', 'render_content' );
	add_action( 'builder_layout_engine_render_content', 'magazine_style_content' );
}


?>
