<?php

/*
Written by Chris Jean for iThemes.com
Version 1.0.0

Version History
	1.0.0 - 2010-01-18
		Initial release version
*/

if ( ! function_exists( 'get_file_data' ) ) {
	// Taken from version 2.9.1 of WP
	function get_file_data( $file, $default_headers, $context = '' ) {
		// We don't need to write to the file, so just open for reading.
		$fp = fopen( $file, 'r' );
		
		// Pull only the first 8kiB of the file in.
		$file_data = fread( $fp, 8192 );
		
		// PHP will close file handle, but we are good citizens.
		fclose( $fp );
		
		if( $context != '' ) {
			$extra_headers = apply_filters( "extra_$context".'_headers', array() );
			
			$extra_headers = array_flip( $extra_headers );
			foreach( $extra_headers as $key=>$value ) {
				$extra_headers[$key] = $key;
			}
			$all_headers = array_merge($extra_headers, $default_headers);
		} else {
			$all_headers = $default_headers;
		}
		
		foreach ( $all_headers as $field => $regex ) {
			preg_match( '/' . preg_quote( $regex, '/' ) . ':(.*)$/mi', $file_data, ${$field});
			if ( !empty( ${$field} ) )
				${$field} = _cleanup_header_comment( ${$field}[1] );
			else
				${$field} = '';
		}
		
		$file_data = compact( array_keys( $all_headers ) ); 
		
		return $file_data;
	}
}

?>
